package org.campbelli.ejb;

import org.campbelli.ejb.bean.UserToken;
import org.jboss.ejb3.annotation.SecurityDomain;
import org.jboss.security.SecurityContextAssociation;
import org.jboss.security.auth.callback.JBossCallbackHandler;

import javax.annotation.Resource;
import javax.annotation.security.PermitAll;
import javax.annotation.security.RolesAllowed;
import javax.ejb.SessionContext;
import javax.ejb.Stateful;
import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;


@SecurityDomain("myPolicy")
@Stateful(name = "MainSessionEJB")
public class MainSessionBean implements MainSessionRemote, MainSessionLocal {

    @Resource
    private SessionContext sessionContext;

    public MainSessionBean() {

    }

    @PermitAll
    public String login(UserToken userToken) {
        LoginContext context = null;
        try {
            CallbackHandler handler = new JBossCallbackHandler(userToken, "paaaaaas");
            Subject subject = new Subject();
            subject.getPrincipals().add(userToken);
            context = new LoginContext("myPolicy", subject, handler);
            context.login();
        } catch (LoginException e) {
            e.printStackTrace();
        }
        return null;
    }

    public String getToken(UserToken userToken) {
        return userToken.toString();
    }

    public String test(String message) {
        System.out.println("------------- String test(String message) {");
        System.out.println("is admin  = "+sessionContext.isCallerInRole("admin"));
        System.out.println("is  1.admin.user_test  = "+sessionContext.isCallerInRole(" 1.admin.user_test"));


        System.out.println(sessionContext.getCallerPrincipal());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getRoles());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getCredential());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getUserPrincipal());

        return "Test " + message;
    }

    public String testHi(String message) {
        System.out.println("------------- String testHi(String message) {");
        System.out.println(sessionContext.getCallerPrincipal());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getCredential());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getUserPrincipal());

        return "Hi " + message;
    }

    @RolesAllowed({"admin"})
    public String testBye(String message) {
        System.out.println("------------- String testBye(String message) {");
        System.out.println(sessionContext.getCallerPrincipal());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getCredential());
        System.out.println(SecurityContextAssociation.getSecurityContext().getUtil().getUserPrincipal());

        return "Bye " + message;
    }

}
