package org.campbelli.ejb.bean;

import java.io.Serializable;
import java.security.Principal;


public class UserToken implements Principal, Serializable {

    static final long serialVersionUID = 42L;

    private Long id;

    private String username;

    private String role;

    public UserToken() {
    }

    public UserToken(String username) {
        this.username = username;
    }

    public UserToken(Long id, String username, String role) {
        this.id = id;
        this.username = username;
        this.role = role;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    @Override
    public String getName() {
        return username;
    }

    @Override
    public String toString() {
        return id + "." + role + "." + username;
    }
}
